



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>洛谷P2480 [SDOI2010]古代猪文（费马小定理，卢卡斯定理，中国剩余定理，线性筛）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">洛谷P2480 [SDOI2010]古代猪文（费马小定理，卢卡斯定理，中国剩余定理，线性筛）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:18:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://www.luogu.org/problemnew/show/P2480" rel="external nofollow noreferrer">洛谷题目传送门</a></p>
<p>蒟蒻惊叹于一道小小的数论题竟能涉及这么多知识点！不过，掌握了这些知识点，拿下这道题也并非难事。</p>
<p>题意一行就能写下来：</p>
<p>给定\(N,G\)，求\(G^{\sum \limits _{d|N}C(N,d)}(\mod999911659)\)</p>
<p>乍一看，指数这么大，要怎么处理好呢？上费马小定理。</p>
<p>平时用费马小定理求逆元用多了，\(a^{p-2}\equiv inv(a)(\mod p)\)，搞得蒟蒻差点忘了它原本的样子\(a^{p-1}=1(\mod p)\)，那原式的指数\(\sum \limits _{d|N}C(N,d)\)就可以直接在\(\mod999911658\)意义下求了。</p>
<p>首先枚举\(d|N\)，这个还好办，直接\(O(\sqrt{N})\)把约数筛出来就好了，注意特判\(N\)为完全平方数的情况。</p>
<p>紧接着我们就碰到了组合数取模。如果模数是个质数还好办，直接上卢卡斯定理。但是\(999911658\)明显不是，把它放到计算器里点一下fact会出来\(2×3×4679×35617\)。</p>
<p>只能用扩展卢卡斯了。所谓扩展卢卡斯，其实就是对于一个非质数的模数，把它质因数分解，求出组合数模每一个质因数的结果。这样等于说得到了一个同余方程组，中国剩余定理还原答案即可。注意对于每一个质因数都要先重新打一遍阶乘表，再对每一个\(N\)的约数算组合数求和取模。</p>
<p>这样指数就求出来了。最后快速幂得到答案。</p>
<pre class="prettyprint linenums"><code>#include&lt;cstdio&gt;<br />
#include&lt;cmath&gt;<br />
#define LL long long<br />
#define R register LL<br />
#define add(a,b,p) a=(a+b)%p<br />
const LL YL=999911659,N=4e4,pr[4]={2,3,4679,35617};<br />
LL f[N],fac[N],res[4],x,y,t;<br />
LL qpow(R b,R k,R p){//快速幂求b^k%p<br />
    R a=1;<br />
    for(;k;k&gt;&gt;=1,b=b*b%p)<br />
        if(k&amp;1)a=a*b%p;<br />
    return a;<br />
}<br />
LL C(R n,R m,R p){//组合数，注意特判<br />
    return n&lt;m?0:fac[n]*qpow(fac[m]*fac[n-m],p-2,p)%p;<br />
}<br />
LL lucas(R n,R m,R p){//同样注意特判<br />
    return m?C(n%p,m%p,p)*lucas(n/p,m/p,p)%p:1;<br />
}<br />
void exgcd(R a,R b){<br />
    if(b)exgcd(b,a%b),t=x,x=y,y=t-a/b*y;<br />
}<br />
int main(){<br />
    fac[0]=1;<br />
    R n,g,m,p=0,i,j,ans=0;<br />
    scanf(&quot;%lld%lld&quot;,&amp;n,&amp;g);<br />
    if(!(g%YL))return puts(&quot;0&quot;),0;//又一次注意特判<br />
    m=sqrt(n);<br />
    for(i=1;i&lt;=m;++i)<br />
        if(!(n%i))f[++p]=i,f[++p]=n/i;<br />
    p-=f[p-1]==f[p];//还是注意特判，防止被算两次<br />
    for(i=0;i&lt;4;++i){<br />
        for(j=1;j&lt;pr[i];++j)<br />
            fac[j]=fac[j-1]*j%pr[i];<br />
        for(j=1;j&lt;=p;++j)<br />
            add(res[i],lucas(n,f[j],pr[i]),pr[i]);<br />
        //下面中国剩余定理，注意x变成正数<br />
        x=1;y=0;exgcd(m=(YL-1)/pr[i],pr[i]);<br />
        add(ans,res[i]*(x%pr[i]+pr[i])*m,(YL-1));<br />
    }<br />
    printf(&quot;%lld\n&quot;,qpow(g,ans,YL));<br />
    return 0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kvmg39.html">python-selenium之firefox、Chrome、Ie运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnyxzj8.html">jquery 通知页面变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k24e68.html">leetCode 354&period; Russian Doll Envelopes</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mk06oq.html">c程序中出现segment error 和 bus error 的原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r606d9.html">js queue dequeue clearQueue  stop</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvoe4z8.html">&lbrack;译&rsqb; ASP&period;NET MVC 6 attribute routing &ndash; the &lbrack;controller&rsqb; and &lbrack;action&rsqb; tokens</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kzk358.html">Maven应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oel4x9.html">在Android Studio进行&OpenCurlyDoubleQuote;简单配置&rdquo;单元测试（Android Junit）</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdmv27q.html">NHibernate初探&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qye0gd9.html">CGROUP</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y7rd0q.html">sql之事务和并发</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zdj4x9.html">自动创建win计划任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojz2o1q.html">Java对Excel数据处理（利用POI解析Excel）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eypw3j9.html">Java-多态经典例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjvxn69.html">mysql使用问题记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvw6438.html">2014年西安区域赛的几道水题（A&period; F&period; K）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r53wgmq.html">python - 自定制property&sol;property的延时计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdje4n7q.html">CSS工具之CSS重置&lpar;CSS Reset&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8konxyjq.html">Codeforces D - The Child and Zoo</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmlgp49.html">Django&lpar;app的概念、ORM介绍及编码错误问题&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2ndoy9.html">odoo11 访问web&sol;database&sol;manager管理数据库页面布局混乱问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvx5ny8.html">linux的convert图片处理工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rle4o9.html">iOS开发简记（2）：自定义tabbar</a>
			</li>
						<li><a href="https://www.batexi.com/a/960g52y9.html">copy constructor</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvxrkl8.html">Java 基础之一对象导论</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o3g7j8.html">VS2010、VS2012、VS2013、VS2015、VS2017各版本产品激活秘钥</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvxr4y8.html">没有 iOS 开发者账号的情况下部署到真机的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5m1jmq.html">centos7下安装php&plus;memcached简单记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyx6rgq.html">D&period; Too Easy Problems</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv0gzk8.html">美食应用 吃了么 beta 测试报告</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
